﻿using System.Linq;
using Xamarin.Forms;
using System.Collections.ObjectModel;
using BonsPratos.Model;
using SQLite.Net;

namespace BonsPratos.Database
{
    public class ManipularDB
    {
        private bool blnEstaVazio;
        private SQLiteConnection BancoDados;
        public ObservableCollection<Estabelecimentos> ListaEstabelecimentos { get; set; }
        public bool EstaVazio
        {
            get
            {
                return blnEstaVazio;
            }

            set
            {
                blnEstaVazio = value;
            }
        }

        public ManipularDB()
        {
            BancoDados = DependencyService.Get<IConexaoDB>().GetConnection("BonsPratosDb.db3");
            BancoDados.CreateTable<Estabelecimentos>();
            ListaEstabelecimentos = new ObservableCollection<Estabelecimentos>(BancoDados.Table<Estabelecimentos>().OrderBy(c => c.NomeEstabelecimento).ToList());

            if (!BancoDados.Table<Estabelecimentos>().Any())
                EstaVazio = true;
            else
                EstaVazio = false;
        }

        public void Adicionar(Estabelecimentos estabelecimento)
        {
            ListaEstabelecimentos.Add(estabelecimento);
            BancoDados.Insert(estabelecimento);
            EstaVazio = false;
        }

        public void Gravar(Estabelecimentos estabelecimento)
        {
            if (estabelecimento.IDRegistro != 0)
                BancoDados.Update(estabelecimento);
        }

        public void Excluir(Estabelecimentos estabelecimento)
        {
            int intIDRegistro = estabelecimento.IDRegistro;

            if (intIDRegistro != 0)
                BancoDados.Delete<Estabelecimentos>(intIDRegistro);

            ListaEstabelecimentos.Remove(estabelecimento);
        }
    }
}
