﻿using BonsPratos.Database;
using BonsPratos.Diversos;
using BonsPratos.Model;
using System;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace BonsPratos.View
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class TelaExclusao : ContentPage
    {
        private ManipularDB AcessoDB;
        private Estabelecimentos estabelecimento;

        public TelaExclusao(ManipularDB AcessoDB, Estabelecimentos EstabelecimentoAtual)
        {
            InitializeComponent();

            this.AcessoDB = AcessoDB;

            estabelecimento = EstabelecimentoAtual;
            BindingContext = estabelecimento;
        }

        private async void ExcluirClick(object sender, EventArgs e)
        {
            bool blnConfirmado = await DisplayAlert("Confirmação", "Deseja realmente excluir o registro?", "Sim", "Não");

            if (blnConfirmado)
            {
                AcessoDB.Excluir(estabelecimento);
                await DisplayAlert("Confirmação", "Registro excluído com sucesso!", "OK");
            }

            await Navigation.PopAsync();
        }
    }
}