﻿using BonsPratos.Database;
using BonsPratos.Model;
using System;
using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace BonsPratos.View
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class TelaPrincipal : ContentPage
    {
        private ManipularDB AcessoDB;

        public TelaPrincipal()
        {
            InitializeComponent();
            AcessoDB = new ManipularDB();
        }

        protected override void OnAppearing()
        {
            base.OnAppearing();
            BindingContext = AcessoDB;

            if (AcessoDB.EstaVazio)
                DisplayAlert("Mensagem de alerta", "Não há registros cadastrados!", "OK");
        }

        private void AdicionarClick(object sender, EventArgs e)
        {
            Navigation.PushAsync(new TelaCadastro(1, AcessoDB, null));
        }

        private void EditarClick(object sender, EventArgs e)
        {
            var estabelecimento = ListaEstabelecimentos.SelectedItem as Estabelecimentos;

            if (estabelecimento != null)
                Navigation.PushAsync(new TelaCadastro(2, AcessoDB, estabelecimento));
            else
                DisplayAlert("Mensagem de aviso", "Selecione um registro para edição!", "OK");
        }

        private void VisualizarClick(object sender, EventArgs e)
        {
            var estabelecimento = ListaEstabelecimentos.SelectedItem as Estabelecimentos;

            if (estabelecimento != null)
                Navigation.PushAsync(new TelaVisualizacao(estabelecimento));
            else
                DisplayAlert("Mensagem de aviso", "Selecione um registro para visualização!", "OK");
        }

        private void ExcluirClick(object sender, EventArgs e)
        {
            var estabelecimento = ListaEstabelecimentos.SelectedItem as Estabelecimentos;

            if (estabelecimento != null)
                Navigation.PushAsync(new TelaExclusao(AcessoDB, estabelecimento));
            else
                DisplayAlert("Mensagem de aviso", "Selecione um registro para exclusão!", "OK");
        }

        private void BackupClick(object sender, EventArgs e)
        {
            AcessoDB = null;

            Navigation.PushAsync(new TelaBackupRestore());

            ManipularDB AcessoDBTemp = new ManipularDB();

            AcessoDB = AcessoDBTemp;
        }
    }
}