﻿using BonsPratos.Model;
using Plugin.ExternalMaps;
using System;

using Xamarin.Forms;
using Xamarin.Forms.Xaml;

namespace BonsPratos.View
{
    [XamlCompilation(XamlCompilationOptions.Compile)]
    public partial class TelaVisualizacao : ContentPage
    {
        private Estabelecimentos estabelecimento;

        public TelaVisualizacao(Estabelecimentos EstabelecimentoAtual)
        {
            InitializeComponent();

            estabelecimento = EstabelecimentoAtual;
            BindingContext = estabelecimento;
        }

        private void VerMapaClick(object sender, EventArgs e)
        {
            try
            {
                CrossExternalMaps.Current.NavigateTo(estabelecimento.NomeEstabelecimento, estabelecimento.Latitude, estabelecimento.Longitude);
            }
            catch
            {
                DisplayAlert("Mensagem de alerta", "Não foi possível exibir o mapa!", "OK");
            }
        }

        private void VerFotoClick(object sender, EventArgs e)
        {
            Navigation.PushAsync(new TelaFoto(estabelecimento.ArquivoFoto));
        }
    }
}