﻿using System;
using Windows.UI.Xaml.Controls;

// O modelo de item de Página em Branco está documentado em https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x416

namespace MultiCalcUWP
{
    /// <summary>
    /// Uma página vazia que pode ser usada isoladamente ou navegada dentro de um Quadro.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Calculadora calculadora;

        public MainPage()
        {
            this.InitializeComponent();

            calculadora = new Calculadora();
        }

        private void btnNumero0_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            Button btnTecla = (Button)sender;
            string strTecla = btnTecla.Content.ToString();
            double dblNumero = Convert.ToDouble(strTecla);
            calculadora.TeclaNumeros(dblNumero);
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnVirgula_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaVirgula();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnIgual_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaIgual();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnSomar_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaAdicao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnSubtrair_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaSubtracao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnMultiplicar_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaMultiplicacao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnDividir_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaDivisao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnLimparCE_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaLimparCE();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnLimparC_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaLimparC();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnElevarQuadrado_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaElevarQuadrado();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnRaizQuadrada_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaRaizQuadrada();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnSeno_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaSeno();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnCosseno_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaCosseno();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnTangente_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaTangente();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnFatorial_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            calculadora.TeclaFatorial();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void btnConverter_Click(object sender, Windows.UI.Xaml.RoutedEventArgs e)
        {
            if (cmbConversao.SelectedIndex != -1)
            {
                calculadora.TeclaConversao(cmbConversao.SelectedIndex);
                txtVisor.Text = calculadora.ValorVisor;
            }
        }
    }
}
