﻿using Android.App;
using Android.Widget;
using Android.OS;
using System;

namespace MultiCalcV1
{
    [Activity(Label = "@string/ApplicationName", MainLauncher = true, Icon = "@drawable/icon")]
    public class MainActivity : Activity
    {
        TextView txtVisor;
        Button btnNumero0, btnNumero1, btnNumero2, btnNumero3, btnNumero4, btnNumero5, btnNumero6, btnNumero7, btnNumero8, 
            btnNumero9, btnVirgula, btnIgual, btnSomar, btnSubtrair, btnMultiplicar, btnDividir, btnLimparCE, btnLimparC,
            btnElevarQuadrado, btnRaizQuadrada, btnSeno, btnCosseno, btnTangente, btnFatorial, btnConverter;
        Spinner spnConversao;
        Calculadora calculadora;
        int intOpcaoConversao = 0;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView (Resource.Layout.Main);

            txtVisor = FindViewById<TextView>(Resource.Id.txtVisor);

            // Teclas numéricas
            btnNumero0 = FindViewById<Button>(Resource.Id.btnNumero0);
            btnNumero1 = FindViewById<Button>(Resource.Id.btnNumero1);
            btnNumero2 = FindViewById<Button>(Resource.Id.btnNumero2);
            btnNumero3 = FindViewById<Button>(Resource.Id.btnNumero3);
            btnNumero4 = FindViewById<Button>(Resource.Id.btnNumero4);
            btnNumero5 = FindViewById<Button>(Resource.Id.btnNumero5);
            btnNumero6 = FindViewById<Button>(Resource.Id.btnNumero6);
            btnNumero7 = FindViewById<Button>(Resource.Id.btnNumero7);
            btnNumero8 = FindViewById<Button>(Resource.Id.btnNumero8);
            btnNumero9 = FindViewById<Button>(Resource.Id.btnNumero9);

            // Teclas de vírgula e sinal de igual
            btnVirgula = FindViewById<Button>(Resource.Id.btnVirgula);
            btnIgual = FindViewById<Button>(Resource.Id.btnIgual);

            // Teclas de operadores
            btnSomar = FindViewById<Button>(Resource.Id.btnSomar);
            btnSubtrair = FindViewById<Button>(Resource.Id.btnSubtrair);
            btnMultiplicar = FindViewById<Button>(Resource.Id.btnMultiplicar);
            btnDividir = FindViewById<Button>(Resource.Id.btnDividir);

            // Teclas de limpeza
            btnLimparCE = FindViewById<Button>(Resource.Id.btnLimparCE);
            btnLimparC = FindViewById<Button>(Resource.Id.btnLimparC);

            // Teclas de funções matemáticas
            btnElevarQuadrado = FindViewById<Button>(Resource.Id.btnElevarQuadrado);
            btnRaizQuadrada = FindViewById<Button>(Resource.Id.btnRaizQuadrada);
            btnSeno = FindViewById<Button>(Resource.Id.btnSeno);
            btnCosseno = FindViewById<Button>(Resource.Id.btnCosseno);
            btnTangente = FindViewById<Button>(Resource.Id.btnTangente);
            btnFatorial = FindViewById<Button>(Resource.Id.btnFatorial);

            // Conversão de unidades de medida
            spnConversao = FindViewById<Spinner>(Resource.Id.spnConversao);
            btnConverter = FindViewById<Button>(Resource.Id.btnConverter);

            calculadora = new Calculadora();

            btnNumero0.Click += OnTeclaNumeros;
            btnNumero1.Click += OnTeclaNumeros;
            btnNumero2.Click += OnTeclaNumeros;
            btnNumero3.Click += OnTeclaNumeros;
            btnNumero4.Click += OnTeclaNumeros;
            btnNumero5.Click += OnTeclaNumeros;
            btnNumero6.Click += OnTeclaNumeros;
            btnNumero7.Click += OnTeclaNumeros;
            btnNumero8.Click += OnTeclaNumeros;
            btnNumero9.Click += OnTeclaNumeros;

            btnVirgula.Click += OnTeclaVirgula;
            btnIgual.Click += OnTeclaIgual;

            btnSomar.Click += OnTeclaSomar;
            btnSubtrair.Click += OnTeclaSubtrair;
            btnMultiplicar.Click += OnTeclaMultiplicar;
            btnDividir.Click += OnTeclaDividir;

            btnLimparCE.Click += OnTeclaLimparCE;
            btnLimparC.Click += OnTeclaLimparC;

            btnElevarQuadrado.Click += OnTeclaElevarQuadrado;
            btnRaizQuadrada.Click += OnTeclaRaizQuadrada;
            btnSeno.Click += OnTeclaSeno;
            btnCosseno.Click += OnTeclaCosseno;
            btnTangente.Click += OnTeclaTangente;
            btnFatorial.Click += OnTeclaFatorial;

            btnConverter.Click += OnTeclaConversao;
            spnConversao.ItemSelected += new EventHandler<AdapterView.ItemSelectedEventArgs>(OnItemSelecionado);
            //ArrayAdapter spinnerAdapter = ArrayAdapter.CreateFromResource(this, Resource.Array.ItensLista, Android.Resource.Layout.SimpleSpinnerItem);
            //spinnerAdapter.SetDropDownViewResource(Android.Resource.Layout.SimpleSpinnerDropDownItem);
            //spnConversao.Adapter = spinnerAdapter;
        }

        private void OnItemSelecionado(object sender, AdapterView.ItemSelectedEventArgs e)
        {
            intOpcaoConversao = e.Position;
        }

        private void OnTeclaNumeros(object sender, EventArgs e)
        {
            Button btnTecla = (Button)sender;
            string strTecla = btnTecla.Text;
            double dblNumero = Convert.ToDouble(strTecla);
            calculadora.TeclaNumeros(dblNumero);
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaVirgula(object sender, EventArgs e)
        {
            calculadora.TeclaVirgula();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaIgual(object sender, EventArgs e)
        {
            calculadora.TeclaIgual();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaSomar(object sender, EventArgs e)
        {
            calculadora.TeclaAdicao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaSubtrair(object sender, EventArgs e)
        {
            calculadora.TeclaSubtracao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaMultiplicar(object sender, EventArgs e)
        {
            calculadora.TeclaMultiplicacao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaDividir(object sender, EventArgs e)
        {
            calculadora.TeclaDivisao();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaLimparCE(object sender, EventArgs e)
        {
            calculadora.TeclaLimparCE();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaLimparC(object sender, EventArgs e)
        {
            calculadora.TeclaLimparC();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaElevarQuadrado(object sender, EventArgs e)
        {
            calculadora.TeclaElevarQuadrado();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaRaizQuadrada(object sender, EventArgs e)
        {
            calculadora.TeclaRaizQuadrada();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaSeno(object sender, EventArgs e)
        {
            calculadora.TeclaSeno();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaCosseno(object sender, EventArgs e)
        {
            calculadora.TeclaCosseno();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaTangente(object sender, EventArgs e)
        {
            calculadora.TeclaTangente();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaFatorial(object sender, EventArgs e)
        {
            calculadora.TeclaFatorial();
            txtVisor.Text = calculadora.ValorVisor;
        }

        private void OnTeclaConversao(object sender, EventArgs e)
        {
            calculadora.TeclaConversao(intOpcaoConversao);
            txtVisor.Text = calculadora.ValorVisor;
        }
    }
}
