﻿using System.ComponentModel;
using Xamarin.Forms;
using System.Windows.Input;

namespace MultiCalcV2.ViewModel
{
    public class CalculadoraViewModel : INotifyPropertyChanged
    {
        private Model.CalculadoraModel calculadora;
        private string strValorVisor;
        private int intOpcaoConversao;

        public ICommand Numero0 { get; set; }
        public ICommand Numero1 { get; set; }
        public ICommand Numero2 { get; set; }
        public ICommand Numero3 { get; set; }
        public ICommand Numero4 { get; set; }
        public ICommand Numero5 { get; set; }
        public ICommand Numero6 { get; set; }
        public ICommand Numero7 { get; set; }
        public ICommand Numero8 { get; set; }
        public ICommand Numero9 { get; set; }
        public ICommand Virgula { get; set; }
        public ICommand Igual { get; set; }
        public ICommand Divisao { get; set; }
        public ICommand Multiplicacao { get; set; }
        public ICommand Subtracao { get; set; }
        public ICommand Adicao { get; set; }
        public ICommand LimparCE { get; set; }
        public ICommand LimparC { get; set; }
        public ICommand ElevarQuadrado { get; set; }
        public ICommand RaizQuadrada { get; set; }
        public ICommand Seno { get; set; }
        public ICommand Cosseno { get; set; }
        public ICommand Tangente { get; set; }
        public ICommand Fatorial { get; set; }
        public ICommand Conversao { get; set; }

        public string ValorVisor
        {
            get
            {
                return strValorVisor;
            }

            set
            {
                strValorVisor = value;
                this.PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(ValorVisor)));
            }
        }

        public int TipoConversao
        {
            get
            {
                return intOpcaoConversao;
            }

            set
            {
                intOpcaoConversao = value;
                this.PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(nameof(TipoConversao)));
            }
        }

        public CalculadoraViewModel()
        {
            calculadora = new Model.CalculadoraModel();
            ValorVisor = calculadora.TextoVisor;

            Numero0 = new Command(() => TeclaNumeros(0));
            Numero1 = new Command(() => TeclaNumeros(1));
            Numero2 = new Command(() => TeclaNumeros(2));
            Numero3 = new Command(() => TeclaNumeros(3));
            Numero4 = new Command(() => TeclaNumeros(4));
            Numero5 = new Command(() => TeclaNumeros(5));
            Numero6 = new Command(() => TeclaNumeros(6));
            Numero7 = new Command(() => TeclaNumeros(7));
            Numero8 = new Command(() => TeclaNumeros(8));
            Numero9 = new Command(() => TeclaNumeros(9));

            Virgula = new Command(() => TeclaVirgula());
            Igual = new Command(() => TeclaIgual());
            Divisao = new Command(() => TeclaDivisao());
            Multiplicacao = new Command(() => TeclaMultiplicacao());
            Subtracao = new Command(() => TeclaSubtracao());
            Adicao = new Command(() => TeclaAdicao());
            LimparCE = new Command(() => TeclaLimparCE());
            LimparC = new Command(() => TeclaLimparC());
            ElevarQuadrado = new Command(() => TeclaElevarQuadrado());
            RaizQuadrada = new Command(() => TeclaRaizQuadrada());
            Seno = new Command(() => TeclaSeno());
            Cosseno = new Command(() => TeclaCosseno());
            Tangente = new Command(() => TeclaTangente());
            Fatorial = new Command(() => TeclaFatorial());
            Conversao = new Command(() => TeclaConversao());

            intOpcaoConversao = 0;
        }

        private void TeclaNumeros(double dblDigito)
        {
            if (calculadora.Digitos <= 10)
            {
                if (calculadora.Virgula)
                {
                    calculadora.FatorDivisao = calculadora.FatorDivisao * 10;
                    calculadora.ValorVisor += (dblDigito / calculadora.FatorDivisao);
                }
                else
                    calculadora.ValorVisor = (calculadora.ValorVisor * 10) + dblDigito;

                calculadora.Digitos++;
                calculadora.ConverterValor();
                ValorVisor = calculadora.TextoVisor;
            }
        }

        private void TeclaVirgula()
        {
            if (!calculadora.Virgula)
            {
                calculadora.Virgula = true;
                calculadora.FatorDivisao = 1;
                calculadora.ValorVisor /= calculadora.FatorDivisao;
                calculadora.ConverterValor();
                ValorVisor = calculadora.TextoVisor;
            }
        }

        private void TeclaIgual()
        {
            calculadora.Calcular();
            ValorVisor = calculadora.TextoVisor;
            calculadora.Inicializar();
        }

        private void TeclaDivisao()
        {
            calculadora.SinalOperador = '/';
            calculadora.Calcular();
            calculadora.Operador = true;
        }

        private void TeclaMultiplicacao()
        {
            calculadora.SinalOperador = 'X';
            calculadora.Calcular();
            calculadora.Operador = true;
        }

        private void TeclaSubtracao()
        {
            calculadora.SinalOperador = '-';
            calculadora.Calcular();
            calculadora.Operador = true;
        }

        private void TeclaAdicao()
        {
            calculadora.SinalOperador = '+';
            calculadora.Calcular();
            calculadora.Operador = true;
        }

        private void TeclaLimparCE()
        {
            calculadora.LimparEntrada();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaLimparC()
        {
            calculadora.LimparTudo();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaElevarQuadrado()
        {
            calculadora.ElevarQuadrado();
            calculadora.ConverterValor();
            ValorVisor = calculadora.TextoVisor;
            calculadora.Inicializar();
        }

        private void TeclaRaizQuadrada()
        {
            calculadora.RaizQuadrada();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaSeno()
        {
            calculadora.CalcularSeno();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaCosseno()
        {
            calculadora.CalcularCosseno();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaTangente()
        {
            calculadora.CalcularTangente();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaFatorial()
        {
            calculadora.CalcularFatorial();
            ValorVisor = calculadora.TextoVisor;
        }

        private void TeclaConversao()
        {
            calculadora.ConverterMedida(intOpcaoConversao);
            ValorVisor = calculadora.TextoVisor;
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}
